//
//  ViewController.m
//  QQ
//
//  Created by mac on 16/7/22.
//  Copyright © 2016年 mac. All rights reserved.
//

#import "ViewController.h"
#import "Common.h"
#import "HomeViewController.h"
@interface ViewController () {
    HomeViewController *_homeViewController;
//    用于记录，由于滑动每次都会叠加
    CGFloat _curX;
    CGFloat _width;
}

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    _curX=self.view.center.x;
    _width=Screen_Width;
    [self configHomeViewController];
    self.view.backgroundColor=[UIColor redColor];
}


- (void)configHomeViewController {
   _homeViewController= [self.storyboard instantiateViewControllerWithIdentifier:@"HomeViewController"];
    [self.view addSubview:_homeViewController.view];
    [_homeViewController.panGesture addTarget:self action:@selector(pan:)];
}

- (void)pan:(UIPanGestureRecognizer *)panRecongnizer {
    CGFloat x=[panRecongnizer translationInView:self.view].x;
    NSLog(@"%lf",x);
    if((self.view.center.x-panRecongnizer.view.center.x)>(_width/2) && x<0 ){
        _curX=panRecongnizer.view.center.x;
        return;
    }else if((self.view.center.x-panRecongnizer.view.center.x)<-(_width/2) && x>0){
        _curX=panRecongnizer.view.center.x;
        return;
    }

    if(panRecongnizer.state == UIGestureRecognizerStateEnded) {
        if(fabs(self.view.center.x-panRecongnizer.view.center.x)<(_width/6)) {
            [self doAnimate:0];
        }else if ((self.view.center.x-panRecongnizer.view.center.x)>(_width/6)) {
            [self doAnimate:(-_width/2)];
        }else if((self.view.center.x-panRecongnizer.view.center.x)<-(_width/6)){
             [self doAnimate:(_width/2)];
        }
        _curX=panRecongnizer.view.center.x;
    }else {

        panRecongnizer.view.center=CGPointMake(_curX+x, self.view.center.y);
        //取出比例
        double rate=fabs(self.view.center.x-panRecongnizer.view.center.x)/_width;
        //求出缩小比例
        CGFloat scale=1-rate*0.4;
        panRecongnizer.view.transform=CGAffineTransformScale(CGAffineTransformIdentity,scale , scale);
    }
}


- (void)doAnimate:(CGFloat)x{
    [UIView animateWithDuration:.2 animations:^{
        double rate=fabs(x)/_width;
        CGFloat scale=1-rate*0.4;
        _homeViewController.view.center=CGPointMake(x+self.view.center.x, self.view.center.y);
        _homeViewController.view.transform=CGAffineTransformScale(CGAffineTransformIdentity,scale , scale);
    } completion:nil];
    

}




- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
